﻿namespace Restful.Net
{
    public interface IUser
    {
        bool IsAuthenticated
        {
            get;
        }

        string UserName
        {
            get;
        }
    }

    public interface IUser<TIdentifier> : IUser
    {
        TIdentifier Identifier
        {
            get;
            set;
        }
    }

    internal class AnonymousUser : IUser
    {
        public bool IsAuthenticated
        {
            get
            {
                return false;
            }
        }
        public string UserName
        {
            get
            {
                return "Anonymous";
            }
        }
    }
}
